package com.css.simulation.resource.scene.mapper;

import api.common.pojo.po.scene.ScenePackageSublistPO;
import api.common.pojo.vo.scene.ScenePackageSublistVO;
import org.apache.ibatis.annotations.*;
import org.apache.ibatis.type.JdbcType;

import java.util.List;


@Mapper
public interface ScenePackageSublistMapper {

    void saveScenePackageSublist(ScenePackageSublistPO params);

    void saveScenePackageSublistAll(List<ScenePackageSublistPO> treeList);

    void deleteScenePackageSublist(String rootId);

    void deleteScenePackageSublistById(String sublistId);

    List<ScenePackageSublistVO> queryScenePackageSublistList(ScenePackageSublistPO params);

    //指标名查唯一
    List<ScenePackageSublistVO> queryBySublistName(ScenePackageSublistPO params);


    @Results(id = "scenePackageSublist", value = {
            @Result(column = "sublist_id", property = "id", jdbcType = JdbcType.VARCHAR),
            @Result(column = "root_id", property = "rootId", jdbcType = JdbcType.VARCHAR),
            @Result(column = "scene_natural_ids", property = "sceneNaturalIds", jdbcType = JdbcType.VARCHAR)
    })
    @Select("select sublist_id, root_id, scene_natural_ids\n" +
            "from scene_package_sublist\n" +
            "where scene_natural_ids like concat('%',#{naturalId},'%')")
    List<ScenePackageSublistPO> selectIdByNaturalId(@Param("naturalId") String naturalId);

    @Update("update scene_package_sublist\n" +
            "set scene_natural_ids =\n" +
            "        if(scene_natural_ids like concat( '%',#{sceneId}, '%'),\n" +
            "           replace(replace(replace(scene_natural_ids, concat(#{sceneId}, ','), ''), concat(',', #{sceneId}), ''),\n" +
            "                   #{sceneId}, ''),\n" +
            "           scene_natural_ids)")
    void updateSceneNaturalIdsBySceneId(@Param("sceneId") String sceneId);
}
